<?php
//--------------------------------------------------------------------
// *** Feed Generator ***
// LAST UPDATE: 2009/04/04
// Version    : 1.52
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// feedgen.php
//
//--------------------------------------------------------------------

require BLOGN_MODDIR."feedgen/function.php";

/* ----- RSS2.0 生成 ----- */
function feedgen_rss_view($user){

	$inifile = BLOGN_MODDIR."feedgen/config.ini";
	$ini = parse_ini_file($inifile);
	$xslfile = BLOGN_SKINDIR."rss2.xsl";

	if ($_GET["u"]) {
		$filelist = blogn_mod_db_log_load_for_user($user, 0, $ini["rss2_count"], $_GET["u"]);
	}elseif ($_GET["c"]) {
		$filelist = blogn_mod_db_log_load_for_category($user, 0, $ini["rss2_count"], $_GET["c"], $vorder);
	}elseif ($_GET["f"] == "cmt") {
		$filelist = blogn_mod_db_comment_load_for_new($user, 0, $ini["rss2_cmt"]);
		$title_add = 'へのコメント最新'.$ini["rss2_cmt"].'件';
	}elseif ($_GET["f"] == "trk") {
		$filelist = blogn_mod_db_trackback_load_for_new(0, $ini["rss2_trk"]);
		$title_add = 'へのトラックバック最新'.$ini["rss2_trk"].'件';
	}else{
		$filelist = blogn_mod_db_log_load_for_viewer($user, 0, $ini["rss2_count"]);
	}

	if ($filelist[0]) {
		$rssdata =  '<?xml version="1.0" encoding="UTF-8"?>';
		if ($ini["rss2_xsl"] == "xslon" && file_exists($xslfile)) {
			$rssdata .= '<?xml-stylesheet href="'.BLOGN_SKINDIR.'rss2.xsl" type="text/xsl" media="screen"?>';
		}
		$rssdata .= '<rss version="2.0">
		<channel>
		<title>'.htmlspecialchars(BLOGN_SITENAME).$title_add.'</title>
		<link>'.BLOGN_HOMELINK.'</link>
		<description>'.htmlspecialchars(BLOGN_SITEDESC).'</description>
		<language>ja</language>
		<lastBuildDate>'.FEEDGEN_RSS_TIME.'</lastBuildDate>
		<generator>BlognPlus Feed Generator</generator>';

		while (list($key, $val) = each($filelist[1])) {
			$rss_tzd = feedgen_calc_timezone($val["date"]);
			$date = feedgen_time_format($val["date"], "rss")." ".$rss_tzd;
			
			if ($_GET["f"] == "cmt") {
				$link = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"].'#cmt'.$val["id"];
				$d_mes = $val["comment"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$d_title = $val["name"].'さんのコメント ≫ '.$c_name;
				$eid = $val["entry_id"];
			}elseif ($_GET["f"] == "trk") {
				$link = $val["url"];
				$d_mes = $val["mes"];
				$d_title = $val["name"].' : '.$val["title"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$eid = $val["entry_id"];
			}else{
				$link = BLOGN_HOMELINK.'index.php?e='.$val["id"];
				$d_mes = preg_replace("/(<img src=|<a href=)\"files\//", "\\1\"".BLOGN_HOMELINK."files/", $val["mes"]); 
				$d_title = $val["title"];
				$d_title = blogn_mbtrim($d_title,100);
				$d_title = blogn_CleanHtml($d_title);
				$d_title = htmlspecialchars($d_title);
				$eid = $val["id"];
				$category1 = blogn_mod_db_category1_load();
				$category2 = blogn_mod_db_category2_load();
				list($c1, $c2) = explode("|", $val["category"]);
				$c_name = $category1[1][$c1]["name"];
				if ($c2) $c_name .= "::".$category2[1][$c2]["name"];
				$d_all = $val["mes"].$val["more"];
				preg_match_all("/<a href=\"files\/([[:alnum:]_-]+\.mp3)\">/i", $d_all, $audio);
			}
			$d_mes = str_replace("]]>", "]]&gt;", $d_mes);
			$d_mes = feedgen_remove_tag($d_mes);
			$d_mes = str_replace('href="index.php', 'href="'.BLOGN_HOMELINK.'index.php', $d_mes);
			$rssdata .= '
		<item>
		<title>'.$d_title.'</title>
		<link>'.$link.'</link>
		<guid>'.$link.'</guid>
		<description><![CDATA[ 
'.$d_mes.'
 ]]></description>';
		if ($audio[1] && file_exists(BLOGN_FILEDIR.$audio[1][0])) {
			$audiosize = filesize(BLOGN_FILEDIR.$audio[1][0]);
			$rssdata .= '<enclosure url="'.BLOGN_HOMELINK.'files/'.$audio[1][0].'" length="'.$audiosize.'" type="audio/mpeg" />';
		}
		$rssdata .= '
		<comments>'.BLOGN_HOMELINK.'index.php?e='.$eid.'#comments</comments>
		<category>'.$c_name.'</category>
		<pubDate>'.$date.'</pubDate>
		</item>';
		}
		$rssdata .= '</channel></rss>';
		$rssdata = ereg_replace("<br>", "<br />", $rssdata);
		$rssdata = ereg_replace("<br />", "<br />\n", $rssdata);
		print $rssdata;
	}
}

/* ----- ATOM1.0 生成 ----- */
function feedgen_atom_one_view($user){

	$inifile = BLOGN_MODDIR."feedgen/config.ini";
	$ini = parse_ini_file($inifile);
	$xslfile = BLOGN_SKINDIR."atom1.xsl";

	if ($_GET["u"]) {
		$filelist = blogn_mod_db_log_load_for_user($user, 0, $ini["atom1_count"], $_GET["u"]);
		$option = '&amp;u='.$_GET["u"];
	}elseif ($_GET["c"]) {
		$filelist = blogn_mod_db_log_load_for_category($user, 0, $ini["atom1_count"], $_GET["c"], $vorder);
		$option = '&amp;c='.$_GET["c"];
	}elseif ($_GET["f"] == "cmt") {
		$filelist = blogn_mod_db_comment_load_for_new($user, 0, $ini["atom1_cmt"]);
		$title_add = 'へのコメント最新'.$ini["atom1_cmt"].'件';
		$option = '&amp;f=cmt';
	}elseif ($_GET["f"] == "trk") {
		$filelist = blogn_mod_db_trackback_load_for_new(0, $ini["atom1_trk"]);
		$title_add = 'へのトラックバック最新'.$ini["atom1_trk"].'件';
		$option = '&amp;f=trk';
	}else{
		$filelist = blogn_mod_db_log_load_for_viewer($user, 0, $ini["atom1_count"]);
	}

	if ($filelist[0]) {
		$rssdata =  '<?xml version="1.0" encoding="utf-8"?>';
		if ($ini["atom1_xsl"] == "xslon" && file_exists($xslfile)) {
			$rssdata .= '<?xml-stylesheet href="'.BLOGN_SKINDIR.'atom1.xsl" type="text/xsl" media="screen"?>';
		}
		$rssdata .= '<feed xml:lang="ja" xmlns="http://www.w3.org/2005/Atom">
		<title type="text">'.htmlspecialchars(BLOGN_SITENAME).$title_add.'</title>
		<link rel="alternate" type="text/html" href="'.BLOGN_HOMELINK.'" />
		<link rel="self" type="application/atom+xml" href="'.BLOGN_HOMELINK.'?mode=atom1'.$option.'" />
		<subtitle type="text">'.htmlspecialchars(strip_tags(BLOGN_SITEDESC)).'</subtitle>
		<id>'.BLOGN_HOMELINK.'</id>
		<author>
			<name>'.FEEDGEN_AUTHOR.'</name>
		</author>
		<updated>'.FEEDGEN_ATOM_TIME.'</updated>
		<generator uri="http://njoy.pekori.to/blog/">BlognPlus Feed Generator</generator> ';

		while (list($key, $val) = each($filelist[1])) {
			$rss_tzd = feedgen_calc_timezone($val["date"]);
			$rss_tzd = substr($rss_tzd,0,3).":".substr($rss_tzd,3,2);
			$date = feedgen_time_format($val["date"], "atom").$rss_tzd;

			if ($_GET["f"] == "cmt") {
				$link = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"].'#cmt'.$val["id"];
				$d_mes = $val["comment"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$c_scheme = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"];
				$d_title = $val["name"].'さんのコメント ≫ '.$c_name;
				$eid = $val["entry_id"];
				$author_name = $val["name"];
				$author_uri = $val["url"];
			}elseif ($_GET["f"] == "trk") {
				$link = $val["url"];
				$d_mes = $val["mes"];
				$d_title = $val["name"].' : '.$val["title"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$c_scheme = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"];
				$eid = $val["entry_id"];
				$author_name = $val["name"];
				$author_uri = $val["url"];
			}else{
				$link = BLOGN_HOMELINK.'index.php?e='.$val["id"];
				$d_mes = preg_replace("/(<img src=|<a href=)\"files\//", "\\1\"".BLOGN_HOMELINK."files/", $val["mes"]); 
				$d_more = preg_replace("/(<img src=|<a href=)\"files\//", "\\1\"".BLOGN_HOMELINK."files/", $val["more"]); 
				$d_title = $val["title"];
				$d_title = blogn_mbtrim($d_title,100);
				$d_title = blogn_CleanHtml($d_title);
				$d_title = htmlspecialchars($d_title);
				$eid = $val["id"];
				$category1 = blogn_mod_db_category1_load();
				$category2 = blogn_mod_db_category2_load();
				list($c1, $c2) = explode("|", $val["category"]);
				$c_name = $category1[1][$c1]["name"];
				if ($c2) $c_name .= "::".$category2[1][$c2]["name"];
				$c_id = str_replace("|", "-", $val["category"]);
				$c_scheme = BLOGN_HOMELINK.'index.php?c='.$c_id;
				$d_all = $val["mes"].$val["more"];
				preg_match_all("/<a href=\"files\/([[:alnum:]_-]+\.mp3)\">/i", $d_all, $audio);
				$userlist = blogn_mod_db_user_load();
				$author_name = $userlist[$val["user_id"]]["name"];
				$author_uri = BLOGN_HOMELINK.'index.php?p='.$val["user_id"];
			}


			$d_mes = feedgen_convert_xhtml($d_mes);
			$d_mes = feedgen_remove_tag($d_mes);
			$d_more = feedgen_convert_xhtml($d_more);
			$d_more = feedgen_remove_tag($d_more);
			$summary = blogn_CleanHtml($d_mes);
			$summary = htmlspecialchars($summary);
			if (strlen($summary) > 255) {
				$summary = blogn_mbtrim($summary,252);
				$summary .= "...";
			}
			$rssdata .= '
		<entry>
		<title type="text">'.$d_title.'</title>
		<link rel="alternate" type="text/html" href="'.$link.'" />
		<id>'.$link.'</id>
		<updated>'.$date.'</updated>
		<author>
			<name>'.$author_name.'</name>
			<uri>'.$author_uri.'</uri>
		</author>
		<summary type="text" xml:lang="ja">'.$summary.'</summary>
		<category term="'.$c_name.'" label="'.$c_name.'" scheme="'.$c_scheme.'" xml:lang="ja" />
		<content type="xhtml" xml:lang="ja">
		<div xmlns="http://www.w3.org/1999/xhtml">
'.$d_mes.$d_more.'
</div> 
		</content>
		</entry>
		';
		}
		$rssdata .= '</feed>';
		$rssdata = ereg_replace("<br>", "<br />", $rssdata);
		$rssdata = ereg_replace("<br />", "<br />\n", $rssdata);
		print $rssdata;
	}
}

/* ----- ATOM0.3 生成 ----- */
function feedgen_atom_view($user){

	$inifile = BLOGN_MODDIR."feedgen/config.ini";
	$ini = parse_ini_file($inifile);
	$xslfile = BLOGN_SKINDIR."atom.xsl";

	if ($_GET["u"]) {
		$filelist = blogn_mod_db_log_load_for_user($user, 0, $ini["atom_count"], $_GET["u"]);
	}elseif ($_GET["c"]) {
		$filelist = blogn_mod_db_log_load_for_category($user, 0, $ini["atom_count"], $_GET["c"], $vorder);
	}elseif ($_GET["f"] == "cmt") {
		$filelist = blogn_mod_db_comment_load_for_new($user, 0, $ini["atom_cmt"]);
		$title_add = 'へのコメント最新'.$ini["atom_cmt"].'件';
	}elseif ($_GET["f"] == "trk") {
		$filelist = blogn_mod_db_trackback_load_for_new(0, $ini["atom_trk"]);
		$title_add = 'へのトラックバック最新'.$ini["atom_trk"].'件';
	}else{
		$filelist = blogn_mod_db_log_load_for_viewer($user, 0, $ini["atom_count"]);
	}

	if ($filelist[0]) {
		$rssdata =  '<?xml version="1.0" encoding="utf-8"?>';
		if ($ini["atom_xsl"] == "xslon" && file_exists($xslfile)) {
			$rssdata .= '<?xml-stylesheet href="'.BLOGN_SKINDIR.'atom.xsl" type="text/xsl" media="screen"?>';
		}
		$rssdata .= '<feed version="0.3" xml:lang="ja" xmlns="http://purl.org/atom/ns#" xmlns:dc="http://purl.org/dc/elements/1.1/">
		<title>'.htmlspecialchars(BLOGN_SITENAME).$title_add.'</title>
		<link rel="alternate" type="text/html" href="'.BLOGN_HOMELINK.'" />
		<tagline>'.htmlspecialchars(BLOGN_SITEDESC).'</tagline> 
		<modified>'.FEEDGEN_ATOM_TIME.'</modified>
		<author>
			<name>'.FEEDGEN_AUTHOR.'</name>
		</author>
		<generator url="http://njoy.pekori.to/blog/">BlognPlus Feed Generator</generator> ';


		while (list($key, $val) = each($filelist[1])) {
			$rss_tzd = feedgen_calc_timezone($val["date"]);
			$rss_tzd = substr($rss_tzd,0,3).":".substr($rss_tzd,3,2);
			$date = feedgen_time_format($val["date"], "atom").$rss_tzd;

			if ($_GET["f"] == "cmt") {
				$link = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"].'#cmt'.$val["id"];
				$d_mes = $val["comment"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$c_scheme = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"];
				$d_title = $val["name"].'さんのコメント ≫ '.$c_name;
				$eid = $val["entry_id"];
				$author_name = $val["name"];
			}elseif ($_GET["f"] == "trk") {
				$link = $val["url"];
				$d_mes = $val["mes"];
				$d_title = $val["name"].' : '.$val["title"];
				$log = blogn_mod_db_log_load_for_entory($user, $val["entry_id"]);
				$c_name = blogn_CleanHtml($log[1]["title"]);
				$c_name = htmlspecialchars($c_name);
				$c_scheme = BLOGN_HOMELINK.'index.php?e='.$val["entry_id"];
				$eid = $val["entry_id"];
				$author_name = $val["name"];
			}else{
				$link = BLOGN_HOMELINK.'index.php?e='.$val["id"];
				$d_mes = $val["mes"];
				$d_mes = preg_replace("/(<img src=|<a href=)\"files\//", "\\1\"".BLOGN_HOMELINK."files/", $d_mes); 
				$d_more = preg_replace("/(<img src=|<a href=)\"files\//", "\\1\"".BLOGN_HOMELINK."files/", $val["more"]); 
				$d_title = $val["title"];
				$d_title = blogn_mbtrim($d_title,100);
				$d_title = blogn_CleanHtml($d_title);
				$d_title = htmlspecialchars($d_title);
				$eid = $val["id"];
				$category1 = blogn_mod_db_category1_load();
				$category2 = blogn_mod_db_category2_load();
				list($c1, $c2) = explode("|", $val["category"]);
				$c_name = $category1[1][$c1]["name"];
				if ($c2) $c_name .= "::".$category2[1][$c2]["name"];
				$c_id = str_replace("|", "-", $val["category"]);
				$c_scheme = BLOGN_HOMELINK.'index.php?c='.$c_id;
				$d_all = $val["mes"].$val["more"];
				preg_match_all("/<a href=\"files\/([[:alnum:]_-]+\.mp3)\">/i", $d_all, $audio);
				$userlist = blogn_mod_db_user_load();
				$author_name = $userlist[$val["user_id"]]["name"];
			}

			$d_mes = str_replace("]]>", "]]&gt;", $d_mes);
			$d_mes = feedgen_remove_tag($d_mes);
			$summary = blogn_CleanHtml($d_mes);
			$summary = htmlspecialchars($summary);
			if (strlen($summary) > 255) {
				$summary = blogn_mbtrim($summary,252);
				$summary .= "...";
			}
			$rssdata .= '
		<entry>
		<title>'.$d_title.'</title>
		<link rel="alternate" type="text/html" href="'.$link.'" />
		<id>'.$link.'</id>
		<issued>'.$date.'</issued>
		<modified>'.$date.'</modified>
		<summary type="text/plain">'.$summary.'</summary>
		<author>
			<name>'.$author_name.'</name>
		</author>
		<dc:subject>'.$c_name.'</dc:subject>
		<content type="text/html" mode="escaped" xml:lang="ja">
		 <![CDATA[ 
'.$d_mes.'
 ]]> 
		</content>
		</entry>
		';
		}
		$rssdata .= '</feed>';
		$rssdata = ereg_replace("<br>", "<br />", $rssdata);
		$rssdata = ereg_replace("<br />", "<br />\n", $rssdata);
		print $rssdata;
	}
}

?>