<?php
//--------------------------------------------------------------------
// *** Feed Generator ***
// LAST UPDATE: 2009/04/04
// Version    : 1.52
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// function.php
//
//--------------------------------------------------------------------

// 時刻変換
function feedgen_time_format($t, $version) {
	switch ($version) {
		case "atom":
			$t = date("Y-m-d", mktime(substr($t,8,2),substr($t,10,2),substr($t,12,2),substr($t,4,2), substr($t,6,2), substr($t,0,4)))."T".date("H:i:s", mktime(substr($t,8,2),substr($t,10,2),substr($t,12,2),substr($t,4,2), substr($t,6,2), substr($t,0,4)));
			return $t;
			break;
		case "rss":
			$t = date("D, d M Y", mktime(substr($t,8,2),substr($t,10,2),substr($t,12,2),substr($t,4,2), substr($t,6,2), substr($t,0,4)))." ".date("H:i:s", mktime(substr($t,8,2),substr($t,10,2),substr($t,12,2),substr($t,4,2), substr($t,6,2), substr($t,0,4)));
			return $t;
			break;
	}
}

// タイムゾーンを計算
function feedgen_calc_timezone($t) {
	$t = date("O", mktime(substr($t,8,2),substr($t,10,2),substr($t,12,2),substr($t,4,2), substr($t,6,2), substr($t,0,4)));
	return $t;
}

// Atom1.0 用 マークアップを XHTML に準拠
function feedgen_convert_xhtml($val) {
	$val = str_replace("&amp;", "&", $val);
	$val = str_replace("&", "&amp;", $val);
	$val = preg_replace("/<img([ ]+[\w\W]+?)(\/)*>/i", "<img\\1 />", $val);
	$val = str_replace("<hr>", "<hr />", $val);
	return $val;
}

// 改行処理
function feedgen_remove_tag($val) {
	$val = blogn_rntag2rn($val);
	$val = preg_replace("/([^\/])><br(\s\/)*>/i", "\\1>", $val);
	return $val;
}

// 最終更新時間を取得
$recent_log = blogn_mod_db_log_load_for_viewer($user, 0, 1);
$mod_time = $recent_log[1][0]["date"];

// Atom 用最終更新時間
$atom_time = feedgen_time_format($mod_time, "atom");
$atom_tzd = feedgen_calc_timezone($mod_time);
$atom_tzd = substr($atom_tzd,0,3).":".substr($atom_tzd,3,2);
$atom_modified = $atom_time.$atom_tzd;
define("FEEDGEN_ATOM_TIME", $atom_modified);

// RSS2.0 用最終更新時間
$rss_time = feedgen_time_format($mod_time, "rss");
$rss_tzd = feedgen_calc_timezone($mod_time);
$rss_modified = $rss_time." ".$rss_tzd;
define("FEEDGEN_RSS_TIME", $rss_modified);

// 管理者名を取得
$users = blogn_mod_db_user_load();
$author = $users[1]["name"];
define ("FEEDGEN_AUTHOR", $author);

?>